using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
//using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Collections.Generic;
using System.Drawing;
using System.IO;

public partial class _Default : System.Web.UI.Page 
{
    public static List<ImageInfo> data = new List<ImageInfo>();
    public static Random random = new Random();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (0 == data.Count)
        {
            foreach (string fileName in Directory.GetFiles(Environment.ExpandEnvironmentVariables("%windir%\\Web\\Wallpaper"), "*.jpg"))
            {
                data.Add(new ImageInfo(fileName));
            }
        }
        List<ImageInfo> dataSubset = new List<ImageInfo>(data);
        if (IsPostBack)
        {
            dataSubset.RemoveAll(delegate(ImageInfo ii) { return (0 == random.Next(0, 2)); });
            System.Threading.Thread.Sleep(2000);  // Fake a processing delay
        }
        DataList1.DataSource = dataSubset;
        DataList1.DataBind();
    }

    [System.Web.Services.WebMethod]
    [Microsoft.Web.Script.Services.ScriptMethod()]
    public static string GetDetails(string contextKey)
    {
        foreach (ImageInfo ii in data)
        {
            if (ii.FileName == contextKey)
            {
                return string.Format("<img src='{0}'><br/>Name: {1}<br/>Dimensions: {2} pixels<br/>Size: {3} bytes", ImageFromFile(ii.FileName, 300, 250), ii.Name, ii.Dimensions, ii.Size);
            }
        }
        return string.Format("[Missing image: {0}]", contextKey);
    }

    public static string ImageFromFile(string fileName, int width, int height)
    {
        return string.Format("ImageFromFile.ashx?fileName={0}&width={1}&height={2}", fileName, width, height);
    }

    public class ImageInfo
    {
        private string _fileName;
        private string _name;
        private Size _dimensions;
        private long _size;
        public ImageInfo(string fileName)
        {
            _fileName = fileName;
            _name = Path.GetFileName(fileName);
            using (Image image = Bitmap.FromFile(fileName))
            {
                _dimensions = image.Size;
            }
            _size = new FileInfo(fileName).Length;
        }
        public string FileName
        {
            get
            {
                return _fileName;
            }
        }
        public string Name
        {
            get
            {
                return _name;
            }
        }
        public string Dimensions
        {
            get
            {
                return string.Format("{0}x{1}", _dimensions.Width, _dimensions.Height);
            }
        }
        public long Size
        {
            get
            {
                return _size;
            }
        }
    }
}
